﻿
Public Class Form1

    ' ===================================================================================================
    '  OPEN CLOSE FORM
    ' ===================================================================================================
    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        ' ------------------------------------------------- 
        ShowWindowTitle()
        FillComboBoxModels(OllamaModelsFile)
        Load_INI()
        SetRichTextBoxFont(TextBox1, "Arial")
        TextBox1.ClearUndo()
        UpdateRunButton()
        ' ------------------------------------------------- 
        Timer20ms.Interval = 20
        Timer20ms.Start()
        EventsAreEnabled = True
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Timer20ms.Stop()
        Save_INI()
    End Sub

    Private Sub Form1_LocationChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.LocationChanged
        If Not EventsAreEnabled Then Return
        LimitFormPosition(Me)
    End Sub

    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        If Not EventsAreEnabled Then Return
        LimitFormPosition(Me)
    End Sub

    Friend Sub ShowWindowTitle()
        Text = AppTitleAndVersion()
    End Sub


    ' ===================================================================================================
    '  REMOTE IP and SERVER
    ' ===================================================================================================
    Private Sub Button_InstallModel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_InstallModel.Click
        InstallModel(ComboBox_Model.Text)
    End Sub

    Private Sub Button_DeleteModel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_DeleteModel.Click
        DeleteModel(ComboBox_Model.Text)
    End Sub

    Private Sub Button_ModelInfo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_ModelInfo.Click
        ModelInfo(ComboBox_Model.Text)
    End Sub

    Private Sub Button_InstalledModels_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_InstalledModels.Click
        InstalledModels()
    End Sub

    Private Sub Button_Edit_Model_List_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_Edit_Model_List.Click
        Process.Start("https://ollama.com/library")
        StartNotepadAndWait(OllamaModelsFile)
        FillComboBoxModels(OllamaModelsFile)
    End Sub

    Private Sub Button_DownloadOllama_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_DownloadOllama.Click
        Process.Start("https://ollama.com/download/OllamaSetup.exe")
    End Sub

    Private OllamaModelsFile As String = "Theremino_Ollama_Models.txt"

    Private Sub StartNotepadAndWait(ByVal file As String)
        Dim p As Process = Process.Start(file)
        p.WaitForInputIdle()
        Do
            System.Threading.Thread.Sleep(100)
        Loop Until p.HasExited
    End Sub

    Private Sub FillComboBoxModels(ByVal file As String)
        If My.Computer.FileSystem.FileExists(file) Then
            Dim oldtext As String = ComboBox_Model.Text
            Dim items() As String = IO.File.ReadAllLines(file)
            ComboBox_Model.Items.Clear()
            For Each s As String In items
                ComboBox_Model.Items.Add(s)
            Next
            ComboBox_Model.Text = oldtext
            If ComboBox_Model.Text = "" Then ComboBox_Model.SelectedIndex = 0
        End If
    End Sub


    ' ===================================================================================================
    '  REMOTE IP and SERVER
    ' ===================================================================================================
    Private Sub TextBox_RemoteIP_DoubleClick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBox_RemoteIP.DoubleClick
        Select Case TextBox_RemoteIP.Text
            Case "localhost" : TextBox_RemoteIP.Text = "192.168.0.2"
            Case "192.168.0.2" : TextBox_RemoteIP.Text = "192.168.0.3"
            Case "192.168.0.3" : TextBox_RemoteIP.Text = "192.168.0.147"
            Case Else : TextBox_RemoteIP.Text = "localhost"
        End Select
    End Sub

    Private Sub Button_StartServer_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_StartServer.Click
        StartOllamaServer()
        TextBox1.Text = "Now the Ollama server is running on this computer." + vbCrLf + vbCrLf + _
                        "To access this server from other devices:" + vbCrLf + _
                        " - Leave the COM window open" + vbCrLf + _
                        " - Use the IP of this computer, from the following list:" + vbCrLf + vbCrLf + _
                        GetLocalIP()
    End Sub


    ' ======================================================================================================
    '   REQUEST
    ' ======================================================================================================
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Ollama.Running = Not Ollama.Running
        UpdateRunButton()
    End Sub

    Private Sub btn_ClearAll_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_ClearAll.Click
        TextBox1.Text = ""
    End Sub

    Private RandomPrompt As Int32 = 0
    Private Sub btm_Random_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btm_Random.Click
        RandomPrompt += 1
        Select Case RandomPrompt
            Case 2 : TextBox1.Text = "Ciao come stai?"
            Case 3 : TextBox1.Text = "Dammi l'elenco delle etnie umane."
            Case 4 : TextBox1.Text = "Quanti abitanti ci sono in Cina?"
            Case 5 : TextBox1.Text = "中国有多少居民？"
            Case Else : RandomPrompt = 1 : TextBox1.Text = "Hello, how are you?"
        End Select
    End Sub

    Friend Sub UpdateRunButton()
        If Ollama.Running Then
            Button1.BackColor = Color.FromArgb(240, 220, 140)
            Button1.Text = "STOP"
            Button1.Refresh()
            Ollama.SendPrompt(TextBox_RemoteIP.Text, ComboBox_Model.Text, TextBox1.Text)
            TextBox1.Text += vbCrLf + vbCrLf
        Else
            Button1.BackColor = Color.FromArgb(240, 255, 230)
            Button1.Text = "Send prompt"
            Ollama.StopAndCloseAll()
        End If
    End Sub

    Private Sub TextBox1_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles TextBox1.KeyDown
        If My.Computer.Keyboard.CtrlKeyDown Then
            If e.KeyValue = 13 Then
                e.Handled = True
                Ollama.Running = True
                UpdateRunButton()
            End If
            If e.KeyValue = Asc("C") Then
                e.Handled = True
                Ollama.Running = False
                UpdateRunButton()
            End If
            'Debug.Print(e.KeyValue.ToString)
        End If
    End Sub


    ' ===================================================================================================
    '  TIMER 1 
    ' ===================================================================================================
    Private Sub Timer20ms_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer20ms.Tick
        Ollama.ReadResponse()
    End Sub


    ' ======================================================================================================
    '   TEST AND DEBUG
    ' ======================================================================================================
    Private Sub TextBox1_DoubleClick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBox1.DoubleClick

    End Sub

    Private Sub Form1_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.DoubleClick

    End Sub


End Class
